#define PIN_LED_RED_PWM 5
#define PIN_LED_GREEN_PWM 6
#define PIN_LED_BLUE_PWM 10

// the setup function runs once when you press reset or power the board
void setup() {
  // initialize digital pin LED_BUILTIN as an output.
  pinMode(PIN_LED_RED_PWM, OUTPUT);
  pinMode(PIN_LED_GREEN_PWM, OUTPUT);
  pinMode(PIN_LED_BLUE_PWM, OUTPUT);

  analogWrite(PIN_LED_RED_PWM, 0);
  analogWrite(PIN_LED_GREEN_PWM, 0);
  analogWrite(PIN_LED_BLUE_PWM, 0);

}

// the loop function runs over and over again forever
void loop() {
  for( float i = 0; i < 6.29; i += 0.05 ) {
    lightUp(i);  // turn the LED on (HIGH is the voltage level)
    delay(100);                      // wait for a second    
  }                    // wait for a second
}

void lightUp( float i) {
  analogWrite(PIN_LED_RED_PWM, ledPower(i, 0));
  analogWrite(PIN_LED_GREEN_PWM, ledPower(i, 1));
  analogWrite(PIN_LED_BLUE_PWM, ledPower(i, 2)); 
}

int ledPower( float i, int pos ) {
  //return ((cos(i) + 1) * 255.0) / 2.0 + pos * 85;
  return (cos(i + (pos/3.0 * 3.14)) + 1) / 2 * 255;
}
